From e94a0752075d11ab8aa7215c8f73cdc44e8a31a9 Mon Sep 17 00:00:00 2001
From: Xiaohe Yang <yangxiaohe2@huawei.com>
Date: Fri, 11 Dec 2020 14:54:10 +0800
Subject: [PATCH] micro_vm: fix x86_64 lightmachine panic with "invalid
 argument" error.

This patch fix error imported by commit 8145eff409.
On x86_64 platform, interrupt-controller has to be created before
creating VCPU.

Signed-off-by: Xiaohe Yang <yangxiaohe2@huawei.com>
---
 device_model/src/micro_vm/mod.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/device_model/src/micro_vm/mod.rs b/device_model/src/micro_vm/mod.rs
index a89b143..94a3e3f 100644
--- a/device_model/src/micro_vm/mod.rs
+++ b/device_model/src/micro_vm/mod.rs
@@ -223,6 +223,9 @@ impl LightMachine {
             )?;
         }
 
+        #[cfg(target_arch = "x86_64")]
+        Self::arch_init(&vm_fd)?;
+
         // Pre init vcpu and cpu topology
         let mut mask: Vec<u8> = Vec::with_capacity(vm_config.machine_config.nr_cpus as usize);
         for _i in 0..vm_config.machine_config.nr_cpus {
@@ -244,9 +247,6 @@ impl LightMachine {
             vcpu_fds.push(Arc::new(vm_fd.create_vcpu(cpu_id)?));
         }
 
-        #[cfg(target_arch = "x86_64")]
-        Self::arch_init(&vm_fd)?;
-
         // Interrupt Controller Chip init
         #[cfg(target_arch = "aarch64")]
         let intc_conf = InterruptControllerConfig {
-- 
2.27.0

